#include "camera.h"
#include "debug.h"
#include "render.h"

Camera g_camera;

void camera_init() {
    LOG_INFO("camera_init");
    g_camera.centre = ZeroVector;
    g_camera.width = 10;
}

static inline
float _camera_height(Camera* self) {
    return self->width * ((float)g_render_resolution.y / (float)g_render_resolution.x);
}

static inline
float _cam_to_world_conversion() {
    return g_render_resolution.x / g_camera.width;
}

SDL_FRect camera_world_to_screen_space(Camera* self, SDL_FRect* world_space) {
    float unit = _cam_to_world_conversion();
    return (SDL_FRect) {
        .x = (g_camera.centre.x - world_space->x + g_camera.width/2.0) * unit,
        .y = (g_camera.centre.y - world_space->y + _camera_height(&g_camera)/2.0) * unit,
        .w = world_space->w * unit,
        .h = world_space->h * unit
    };
}
